/*  bootstrap for Jaron 2.1

    Allows for putting a single mode to be executed
    on the command line. That mode will be run repeatedly.
   
    When a user presses ^C, it will prompt them for
    the password in PASSWD.
   
    This program will execute modes in a random order.
    If you add a mode, you will need to modify this
    file as well.
   
    ---------------------------------------------------------------------
    
    Jaron - a text mode screensaver.
    Copyright (C) 2004  John Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>

#define MESSAGE "Jaron 2.1 - The screen is locked. Please enter the password."
#define SUCCESS_MSG "Correct!"
#define FAIL_MSG "The password you entered is incorrect."
#define PASSWD "password"
#define PROMPT "Password:"
#define NUM_COLS 80
#define NUM_ROWS 25
#define NUM_MODES 3

int enter_password(void);

int main(int argc, char *argv[])
{	int random_number;
	if (signal(SIGINT, &enter_password) == SIG_ERR)
	{	printf("Can't register ^C handler!");
		exit(1);
	}
	if(argc == 2) 
	{	if(strcmp(argv[1], "marquee") == 0)
			for(;;) mode1();
		if(strcmp(argv[1], "bounce") == 0)
			for(;;) mode2();
		if(strcmp(argv[1], "Linux") == 0)
			for(;;) mode3();
		printf("jaron - a text mode screensaver.\n");
		printf("usage: jaron [mode]\n");
		printf("\n");
		printf("possible modes: \'marquee\', \'bounce\', or \'Linux\'.\n");
	}
	else
	{	for(;;)
		{ 	random_number = get_random(NUM_MODES);
			switch(random_number)	
			{	case 0:
					mode1();	
					break;
				case 1:
					mode2();
				 	break; 
				case 2:
					mode3();
					break;
			} 
		} 
	}
}
	
int enter_password(void)
{	char *entered_password[80];
	clear();
	refresh();
	move((NUM_ROWS / 4), ((NUM_COLS - strlen(MESSAGE)) / 2));
	printw(MESSAGE);
	move(((NUM_ROWS / 4) + 4), ((NUM_COLS - strlen(PROMPT)) / 2));
	printw(PROMPT);
	noecho();
	refresh();
	getnstr(entered_password, 80);
	if(strcmp(entered_password, PASSWD) == 0)
	{	move(((NUM_ROWS / 4) * 3), ((NUM_COLS - strlen(SUCCESS_MSG)) / 2));
		printw(SUCCESS_MSG);
		refresh();
		usleep(1000000);
		clear();
		refresh();
		endwin();
		exit(0);
	}
	else
	{	move(((NUM_ROWS / 4) * 3), ((NUM_COLS - strlen(FAIL_MSG)) / 2));
		printw(FAIL_MSG);
		refresh();
		usleep(3000000);
		clear();		
		refresh();
	}
}